CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
   
  MyStringSize      = 20
  CarriageReturn    = 13
  DigitsInMyNumbers = 6
  
OBJ
  Debug   : "FullDuplexSerialPlus"
  fMath   : "FloatMath"
  fString : "FloatString"
   

VAR
  byte MyArray[MyStringSize]
  long StringPointer
  long Digit
   
PUB ManipulateString_Demo | a, b, c, Index, StrLength

 
  Debug.start(31, 30, 0, 57600)

  repeat
    WaitCnt(ClkFreq + cnt)
    a := 0.0001
    b := 1.0

    c := fmath.FAdd(a, b)

    StringPointer := fstring.FloatToString(c)
    
    'ATTENTION when using the command bytemove !
    'the programmer is FULL responsible of
    '1: adress of first parameter
    '2: adress of second parameter
    '3 how many bytes are moved
    'errors in these parameters can cause program crashes
    'or ABSOLUTE strange behaviour of the code !
    bytemove(@MyArray,StringPointer,MyStringSize) 
     
    debug.str(String("direct output of 'fstring.FloatToString(c)=' "))
    debug.str(fstring.FloatToString(c)) 
    debug.Tx(CarriageReturn)
    debug.Tx(CarriageReturn)

    debug.str(String("content of MyArray= "))
    debug.str(@MyArray)
    debug.Tx(CarriageReturn)
    debug.Tx(CarriageReturn)

    StrLength := strsize(MyArray)
    debug.str(String("characters of MyArray",CarriageReturn))
    repeat Index from 0 to DigitsInMyNumbers - 1 
      debug.str(String("MyArray["))
      debug.dec(Index)
      debug.str(String("]="))
      debug.Tx(MyArray[Index])
      debug.Tx(CarriageReturn)
      

    debug.str(String("add 8 to the FIRST digit in the string MyArray",CarriageReturn))
    'characters are ASCII-coded.
    'ASCII-code of "0" is 48
    'so substract ASCII-code of "0" to get the integervalue 0
    'ASCII-code of "1" is 49    49 - "0" is the same as 49 - 48 = 1
    Digit := MyArray[0] - "0"   
    MyArray[0] := "0" + Digit  + 8     
 
    debug.str(String("content of MyArray= "))
    debug.str(@MyArray)
    debug.Tx(CarriageReturn)
    debug.Tx(CarriageReturn)

    debug.str(String("add 3 behind . in the string MyArray",CarriageReturn))
    Digit := MyArray[2] - "0" 'characters are ASCII-coded.   ASCII-code of "0" is 48 so substract ASCII-code of "0" 
    MyArray[2] := "0" + Digit  + 3     
    debug.Tx(CarriageReturn)
 
    debug.str(String("content of MyArray= "))
    debug.str(@MyArray)
    debug.Tx(CarriageReturn)
    debug.str(String("----------------------------------------------------"))
    debug.Tx(CarriageReturn)
    debug.Tx(CarriageReturn)
